//------------------------------------------------------------------------------
// This file is part of the OpenStructure project <www.openstructure.org>
//
// Copyright (C) 2008-2010 by the OpenStructure authors
//
// This library is free software; you can redistribute it and/or modify it under
// the terms of the GNU Lesser General Public License as published by the Free
// Software Foundation; either version 3.0 of the License, or (at your option)
// any later version.
// This library is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
// details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this library; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
//------------------------------------------------------------------------------
#ifndef OST_PROFILE_HH
#define OST_PROFILE_HH

#include <ost/module_config.hh>

#if OST_PROFILING_ENABLED && !defined(WIN32)
#include <sys/time.h>
#endif

namespace ost {

#if OST_PROFILING_ENABLED==0 || defined(WIN32)

class Profile {
public:
  Profile(const String&) {}
  ~Profile() {}
};

#else

class Profile {
public:
  Profile(const String& msg);
  ~Profile();
private:
  String msg_;
  struct timeval start_;
};

#endif
  
}


#endif
